ScriptName MessageBoxPanel Extends Form
{ Yes/Noの二択を編集できるカスタムメッセージボックスUI }

Bool bMenuOpen
String messageText
Bool withCancel
String acceptLabel
String cancelLabel
Int sound_type
Int platform
Bool answer

bool function ShowMessage(string a_message, bool a_withCancel = true, string a_acceptLabel = "$Accept", string a_cancelLabel = "$Cancel", int a_sound = 0)
	If(bMenuOpen)
		Return -1
	EndIf
	bMenuOpen = True
	messageText = a_message
	withCancel = a_withCancel
	acceptLabel = a_acceptLabel
	cancelLabel = a_cancelLabel
	sound_type = a_sound
	platform = (Game.UsingGamepad() as Int)
	MBP_Open(Self)
	While(bMenuOpen)
		Utility.WaitMenuMode(0.1)
	EndWhile
	MBP_Release(Self)
	Return answer
EndFunction

Function MBP_Open(Form akClient)
	akClient.RegisterForModEvent("MessageBoxPanelOpen", "OnMBP")
	akClient.RegisterForModEvent("MessageBoxPanelClose", "OnMBP")
	UI.OpenCustomMenu("skyui/MessageBoxPanel")
EndFunction

Function MBP_Release(Form akClient)
	akClient.UnregisterForModEvent("MessageBoxPanelOpen")
	akClient.UnregisterForModEvent("MessageBoxPanelClose")
EndFunction

Function SetupPanel(int a_platform, string a_message, string a_acceptLabel, string a_cancelLabel, int a_sound)
	Int iHandle = UICallback.Create("CustomMenu", "_root.MessageBoxPanel.setupPanel")
	If(iHandle)
		UICallback.PushInt(iHandle, a_platform)
		UICallback.PushString(iHandle, a_message)
		UICallback.PushString(iHandle, a_acceptLabel)
		UICallback.PushString(iHandle, a_cancelLabel)
		UICallback.PushInt(iHandle, a_sound)
		UICallback.Send(iHandle)
	else
		debug.trace("@ [MessageBoxPanel] - SetupPanel Error")
	EndIf
EndFunction

Event OnMBP(String asEventName, String asStringArg, Float afNumArg, Form akSender)
	If (asEventName == "MessageBoxPanelOpen")
		If !withCancel
			cancelLabel = ""
		endIf
		; debug.trace("# [MBP] platform = " + platform + " , messageText = " + messageText + " , " + acceptLabel + " , " + cancelLabel)
		SetupPanel(platform, messageText, acceptLabel, cancelLabel, sound_type)
	elseIf (asEventName == "MessageBoxPanelClose")
		If afNumArg == 1.0
			answer = true
		else
			answer = false
		endIf
		bMenuOpen = False
	EndIf
EndEvent
