scriptname NoticeWidget extends SKI_WidgetBase
{ お知らせ表示用ウィジェット }

bool _visible = false
bool _bgvisible = true
float _bgalpha = 100.0

bool Property Visible
	bool function get()
		return _visible
	endFunction
	function set(bool a_val)
		_visible = a_val
		if (Ready)
			UI.InvokeBool(HUD_MENU, WidgetRoot + ".setVisible", _visible)
		endIf
	endFunction
endProperty

bool Property BackgroundVisible
	bool function get()
		return _bgvisible
	endFunction
	function set(bool a_val)
		_bgvisible = a_val
		if (Ready)
			UI.InvokeBool(HUD_MENU, WidgetRoot + ".setBackgroundVisible", _bgvisible)
		endIf
	endFunction
endProperty

float Property BackgroundAlpha
	float function get()
		return _bgalpha
	endFunction
	function set(float a_val)
		_bgalpha = a_val
		if (Ready)
			UI.InvokeFloat(HUD_MENU, WidgetRoot + ".setBackgroundAlpha", _bgalpha)
		endIf
	endFunction
endProperty

Function ShowNotice(String messageText, Bool wordwrap, string a_color = "#FFFFFF")
	Int iHandle = UICallback.Create(HUD_MENU, WidgetRoot + ".ShowNotice")
	If(iHandle)
		UICallback.PushString(iHandle, messageText)
		UICallback.PushBool(iHandle, wordwrap)
		UICallback.PushString(iHandle, a_color)
		UICallback.Send(iHandle)
	else
		debug.trace("@ [NoticeWidget] - ShowNotice Setup Error")
	EndIf
EndFunction

; Widget Event -----------------------------

event OnWidgetInit()
	X = 640
	Y = 150
endEvent

event OnWidgetReset()
	parent.OnWidgetReset()
	UI.InvokeBool(HUD_MENU, WidgetRoot + ".setVisible", _visible)
	UI.InvokeBool(HUD_MENU, WidgetRoot + ".setBackgroundVisible", _bgvisible)
	UI.InvokeFloat(HUD_MENU, WidgetRoot + ".setBackgroundAlpha", _bgalpha)
endEvent

string function GetWidgetSource()
	return "../obachan/NoticeWidget.swf"
endFunction

string function GetWidgetType()
	return "NoticeWidget"
endFunction
