﻿ScriptName Rename_MCM Extends SKI_ConfigBase

Rename_Main Property RM auto
Spell Property RenameSpell Auto
Actor Player

Event OnConfigInit()
	ModName = "Rename tool"
	Pages = new string[1]
	Quest MainQuest = (Game.GetFormFromFile(0x800, "RenameTool.esp") As Quest)
	RM = MainQuest as Rename_Main
	Player = Game.GetPlayer()
EndEvent

event OnGameReload()
	parent.OnGameReload()
	RM.RegisterConfirmKey()
	RM.SwinchUIlog()
	RM.RegisterForMenu("Crafting Menu")
	if RM.RenameMode
		RM.StopGetTargetMode()
	endIf
endEvent

int function GetVersion()
	return 100 ; v1.00
endFunction

string Function GetStringVer()
	int ver = GetVersion()
	If ver == 0
		Return "[Error]"
	else
		Return "v" + (ver * 0.01)
	endIf
EndFunction

Event OnVersionUpdate(int a_version)
	debug.trace("# [Rename Tool] - Update - ver." + CurrentVersion + " --> ver." + a_version)
EndEvent

; ==============================================
event OnPageReset(string page)
	ChangeNameMenu()
endEvent
; ==============================================
Event OnConfigOpen()
endEvent
Event OnConfigClose()
EndEvent
; ==============================================
Function ChangeNameMenu()
	SetTitleText("$ChangeNamesPageTitle")
	SetCursorFillMode(TOP_TO_BOTTOM)

	; プレイヤーの名前の変更
	AddHeaderOption("$PlayerModeHeader")
	AddTextOptionST("ChangePlayerName", "$ChangePlayerName", "$Mark_Angle")
	AddEmptyOption()

	; クロスヘア対象の名前の変更
	AddHeaderOption("$CrosshairModeHeader")
	AddTextOptionST("StartGetTargetMode", "$StartGetTargetMode", "$Mark_Angle")
	AddTextOptionST("StopGetTargetMode", "$StopGetTargetMode", "$Mark_Angle")
	AddEmptyOption()

	; コンソール用
	AddHeaderOption("$ConsoleModeHeader")
	AddTextOptionST("openKanamenuForConsole", "$openKanamenuForConsole", "$Mark_Angle")
	AddTextOption("$ConsoleText", RM.getConsoleText())
	AddEmptyOption()

	SetCursorPosition(1)

	; ホットキー
	AddHeaderOption("$HotkeyHeader")
	AddKeyMapOptionST("RegistConfirmKey", "$RegistConfirmKey", RM.ConfirmKey)
	AddKeyMapOptionST("RegistSubKey", "$RegistSubKey", RM.CtrlKey)
	AddTextOptionST("Unregist_Hotkey", "$Unregist_Hotkey", "$Go_ahead")
	AddEmptyOption()

	; System States
	AddHeaderOption("$SystemStatusHeader")
	AddTextOption("$RM_Version", GetStringVer())
	AddToggleOptionST("AddRenameSpell","$AddRenameSpell", Player.HasSpell(RenameSpell))
	AddToggleOptionST("ToggleDebugMode","$ToggleDebugMode", RM.debugMode)
endFunction

state ChangePlayerName
	event OnHighlightST()
		SetInfoText("$ChangePlayerName_Highlight")
	endEvent
	event OnSelectST()
		RM.changePlayerName()
	endEvent
endState

state StartGetTargetMode
	event OnHighlightST()
		SetInfoText("$StartGetTargetMode_Highlight")
	endEvent
	event OnSelectST()
		RM.RenameMode = true
		ShowMessage("$StartGetTargetMode_done", false, "$Yes")
		RM.StartGetTargetMode()
	endEvent
endState

state StopGetTargetMode
	event OnHighlightST()
		SetInfoText("$StopGetTargetMode_Highlight")
	endEvent
	event OnSelectST()
		RM.RenameMode = false
		ShowMessage("$StopGetTargetMode_done", false, "OK")
		RM.StopGetTargetMode()
	endEvent
endState

state RegistConfirmKey
	event OnHighlightST()
		SetInfoText("$RegistConfirmKey_Highlight")
	endEvent
	event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
		if !KeyConflict(newKeyCode, conflictControl, conflictName)
			RM.UnregisterConfirmKey()
			RM.ConfirmKey = newKeyCode
			SetKeyMapOptionValueST(RM.ConfirmKey)
			RM.RegisterConfirmKey()
		endIf
	endEvent
	event OnDefaultST()
		RM.UnregisterConfirmKey()
		RM.ConfirmKey = 47
		SetKeyMapOptionValueST(RM.ConfirmKey)
		RM.RegisterConfirmKey()
	endEvent
endState

state RegistSubKey
	event OnHighlightST()
		SetInfoText("$RegistSubKey_Highlight")
	endEvent
	event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
		if !KeyConflict(newKeyCode, conflictControl, conflictName)
			RM.CtrlKey = newKeyCode
			SetKeyMapOptionValueST(RM.CtrlKey)
		endIf
	endEvent
	event OnDefaultST()
		RM.CtrlKey = 29
		SetKeyMapOptionValueST(RM.CtrlKey)
	endEvent
endState
state Unregist_Hotkey
	event OnHighlightST()
		SetInfoText("$Unregist_Hotkey_Highlight")
	endEvent
	event OnSelectST()
		if (RM.ConfirmKey > -1)
			RM.UnregisterConfirmKey()
		endif
		RM.ConfirmKey = -1
		RM.CtrlKey = -1
		ForcePageReset()
		ShowMessage("$Hotkey_unregist_done", false)
	endEvent
endState

bool function KeyConflict(int newKeyCode, string conflictControl, string conflictName)
	bool continue = true
	if (conflictControl != "")
		string msg
		if (conflictName != "")
			msg = "$MCM_hotkeyWarn1{" + conflictName + "}{" + conflictControl + "}"
		else
			msg = "$MCM_hotkeyWarn2{" + conflictControl + "}"
		endIf
		continue = ShowMessage(msg, true, "$Yes", "$No")
	endIf
	return !continue
endFunction

String Function GetCustomControl(int keyCode)
	if(keyCode == RM.ConfirmKey)
		return "$RegistConfirmKey"
	elseif(keyCode == RM.CtrlKey)
		return "$RegistSubKey"
	endIf
EndFunction

state openKanamenuForConsole
	event OnHighlightST()
		SetInfoText("$ConsoleMode_Highlight")
	endEvent
	event OnSelectST()
		RM.openKanamenuForConsole()
	endEvent
endState

state AddRenameSpell
	event OnHighlightST()
		SetInfoText("$AddRenameSpell_Highlight")
	endEvent
	event OnSelectST()
		if Player.HasSpell(RenameSpell)
			Player.RemoveSpell(RenameSpell)
			ShowMessage("$RemoveSpellMessage", false, "OK")
		else
			Player.AddSpell(RenameSpell)
			ShowMessage("$AddSpellMessage", false, "OK")
		endif
		SetToggleOptionValueST(Player.HasSpell(RenameSpell))
	endEvent
endState

state ToggleDebugMode
	event OnHighlightST()
		SetInfoText("$ToggleDebugMode_Highlight")
	endEvent
	event OnSelectST()
		RM.debugMode = !RM.debugMode
		RM.SwinchUIlog()
		SetToggleOptionValueST(RM.debugMode)
	endEvent
	event OnDefaultST()
		RM.debugMode = false
		RM.SwinchUIlog()
		SetToggleOptionValueST(RM.debugMode)
	endEvent
endState
