Scriptname Rename_Main extends Quest

EffectShader Property targetLightEffect Auto
int Property ConfirmKey = 47 Auto  ; [V]
int Property CtrlKey = 29 Auto ; Left Ctrl
bool Property debugMode = false auto
bool Property RenameMode = false Auto
ObjectReference tempRef
string tempTargetName
Actor Player
Bool isEnchantConstruct = false
Bool isInBlockMenu = false

; Custom UI
Form UIcliant
MessageBoxPanel MBP
UI_KanaMenu KanaMenu
Rename_NoticeWidget NW

; MCM
Rename_MCM MCM

Event OnInit()
	Player = Game.GetPlayer()
	UIcliant = self as Form
	MBP = UIcliant as MessageBoxPanel
	KanaMenu = UIcliant as UI_KanaMenu
	Quest myQuest = self as Quest
	NW = myQuest as Rename_NoticeWidget
	targetLightEffect = (Game.GetFormFromFile(0xFE68C, "Skyrim.esm") As EffectShader) ; GhostRedShader
	Quest MCMquest = (Game.GetFormFromFile(0x801, "RenameTool.esp") As Quest)
	MCM = MCMquest as Rename_MCM
	log("MBP = " + MBP + " , KanaMenu = " + KanaMenu + "LightEffext = " + targetLightEffect + " , MCM = " + MCM)
EndEvent

Event OnMenuOpen(String MenuName)
	log("OnMenuOpen - " + MenuName)
	isInBlockMenu = true
	If MenuName == "Crafting Menu"
		Int currentframe = UI.GetInt("Crafting Menu", "_root.Menu._currentframe")
		log("Crafting Menu Open : \̃t[" + currentframe)
		if currentframe == 3 ; t􃁃j[
			isEnchantConstruct = true
			isInBlockMenu = false
		endif
	endIf
endEvent
Event OnMenuClose(String MenuName)
	isInBlockMenu = false
	isEnchantConstruct = false
endEvent

; Player Name ===================
Function changePlayerName()
	string myName = KanaMenu.ShowKanaMenu(Player.getbaseobject().getname())
	if StringUtil.GetLength(myName) < 1
		return
	else
		bool done =MBP.ShowMessage("$DoYouChangePlayerName{" + myName + "}", true, "$Change", "$Cancel")
		if done
			Player.getbaseobject().setname(myName)
		endif
	endif
EndFunction

; Enchant Item Name ===================
Function changeEnchantItemName()
	string orgName = UI.GetString("Crafting Menu", "_root.Menu.ItemInfoHolder.ItemInfo.ItemText.ItemTextField.text")
	string newName = KanaMenu.ShowKanaMenu(orgName)
	if StringUtil.GetLength(newName) < 1
		return
	else
		Int iHandle = UICallback.Create("Crafting Menu", "_root.Menu.EditItemName")
		If (iHandle)
			UICallback.PushString(iHandle, newName)
			UICallback.PushInt(iHandle, 100)
			UICallback.Send(iHandle)
		else
			debug.trace("@ [RenameTool] changeEnchantItemName - iHandle쐬s")
		endif
		MBP.ShowMessage("$changeEnchantItemName", false)
	endif
EndFunction

; Console ===================
Function inputConsole()
	string command = "help \"" + KanaMenu.consoleText + "\""
	UI.SetString("Console", "_global.Console.ConsoleInstance.CommandEntry.text", command)
EndFunction

Function openKanamenuForConsole()
	string newtext = KanaMenu.ShowKanaMenu(KanaMenu.consoleText)
	if newtext == ""
		return
	else
		KanaMenu.consoleText = newtext
	endif
	If UI.IsMenuOpen("Journal Menu")
		MCM.ForcePageReset()
	EndIf
EndFunction

String Function getConsoleText()
	return KanaMenu.consoleText
EndFunction

; Target Reference Name ===================
Function StartGetTargetMode()
	RenameMode = true
	RegisterForCrosshairRef()
	NW.ShowNotice("$NoticeMessage", true)
	log("NXwAΏێ擾Jn")
endFunction

Function StopGetTargetMode()
	RenameMode = false
	UnregisterForCrosshairRef()
	tempRef = none
	tempTargetName = ""
	NW.DisableNotice()
	log("NXwAΏێ擾I")
endFunction

Event OnCrosshairRefChange(ObjectReference ref)
	If ref
		targetLightEffect.Play(ref, 0.5)
		tempRef = ref
		tempTargetName = getObjectName(ref)
		log("Target = " + tempTargetName)
		targetLightEffect.Stop(ref)
	EndIf
EndEvent

Function RenameActor(Actor target)
	string name = target.GetLeveledActorBase().GetName()
	if name
		target.setDisplayName(name, true)
	else
		target.setDisplayName("Unknown", true)
	endif
EndFunction

; Hotkey ===================
Event OnKeyDown(Int KeyCode)
	if KeyCode == ConfirmKey
		if !Utility.IsInMenuMode()
			if RenameMode
				if tempTargetName == ""
					MBP.ShowMessage("$FirstGetTarget", false, "OK")
					return
				endif
				string myName = KanaMenu.ShowKanaMenu(tempTargetName)
				if StringUtil.GetLength(myName) < 1
					return
				endif
				bool done =MBP.ShowMessage("$DoYouChangeTargetName{" + tempTargetName + "}{" + myName + "}", true, "$Change", "$Cancel")
				if done
					bool answer
					if !(tempRef.setDisplayName(myName))
						if !(tempRef.setDisplayName(myName, true))
							answer = MBP.ShowMessage("$CannotChangeTargetName{" + tempTargetName + "}", true, "$StopGetTargetMode", "$CarryOn")
						else
							answer = MBP.ShowMessage("$CanChangeTargetName{" + tempTargetName + "}{" + myName + "}", true, "$StopGetTargetMode", "$CarryOn")
						endif
					else
						answer = MBP.ShowMessage("$CanChangeTargetName{" + tempTargetName + "}{" + myName + "}", true, "$StopGetTargetMode", "$CarryOn")
					endIf
					if answer == 0
						tempRef = none
						tempTargetName = ""
						return
					else
						StopGetTargetMode()
					endif
				else
					return
				endif
			else ; OύX[hȂꍇ
				If !isInBlockMenu
					If !Game.UsingGamepad()
						If CtrlPressed()
							If isEnchantConstruct ; t􃁃j[
								changeEnchantItemName()
							else
								StartGetTargetMode()
							endif
						endif
					else ; Gamepad
						If isEnchantConstruct ; t􃁃j[
							changeEnchantItemName()
						endif
					endif
				endif
			endif
		else ; Menumode
			If CtrlPressed()
				inputConsole()
			endif
		endif
	endif
endEvent

Function RegisterConfirmKey()
	if ConfirmKey > -1
		RegisterForKey(ConfirmKey)
	endif
EndFunction
Function UnregisterConfirmKey()
	if ConfirmKey > -1
		UnregisterForKey(ConfirmKey)
	endif
EndFunction

;/===========================================
	Utility
============================================/;
Function log(String Msg, Bool isError = false)
	If debugMode
		If isError
			Debug.Trace("@ [RenameTool] - Error - " + Msg)
		else
			Debug.Trace("# [RenameTool] " + Msg)
		endif
	endIf
EndFunction
Function SwinchUIlog()
	if debugMode
		RegisterForModEvent("UIlog", "OnUIlog")
	else
		UnRegisterForModEvent("UIlog")
	endif
EndFunction
Event OnUIlog(String asEventName, String asStringArg, Float afNumArg, Form akSender)
	If debugMode
		Debug.Trace( "[UI] - [Rename] - " + asStringArg)
	endif
EndEvent
string Function getObjectName(ObjectReference targetRef)
	string name = targetRef.GetDisplayName()
	If name == ""
		name = targetRef.getbaseobject().getname()
	endIf
	Return name
EndFunction
bool function CtrlPressed()
	return Input.GetNumKeysPressed() > 1 && (Input.IsKeyPressed(CtrlKey) || (CtrlKey == 29 && Input.IsKeyPressed(157)) || (CtrlKey == 157 && Input.IsKeyPressed(29)))
endFunction

