﻿ScriptName UI_KanaMenu Extends Form
{ 日本語かな入力メニュー }

Bool bMenuOpen
String sInitialText
String sInput
int caret
String[] Property stockwords Auto
String Property consoleText = "無し" Auto

Event OnInit()
	stockwords = new String[6]
	stockwords[0] = "ストック1"
	stockwords[1] = "ストック2"
	stockwords[2] = "ストック3"
	stockwords[3] = "ストック4"
	stockwords[4] = "ストック5"
	stockwords[5] = "ストック6"
EndEvent

String Function ShowKanaMenu(String asInitialText = "")
	If(bMenuOpen)
		Return ""
	EndIf
	bMenuOpen = True
	sInput = ""
	sInitialText = asInitialText
	KanaMenu_Open(Self)
	While(bMenuOpen)
		Utility.WaitMenuMode(0.1)
	EndWhile
	KanaMenu_Release(Self)
	Return sInput
EndFunction

Function KanaMenu_Open(Form akClient)
	akClient.RegisterForModEvent("UI_KanaMenuOpen", "OnKanaMenu")
	akClient.RegisterForModEvent("UI_KanaMenuClose", "OnKanaMenu")
	akClient.RegisterForModEvent("UI_KanaMenuCaret", "OnKanaMenu")
	akClient.RegisterForModEvent("UI_KanaMenuStock", "OnKanaMenu")
	akClient.RegisterForModEvent("UI_KanaMenuConsole", "OnKanaMenu")
	UI.OpenCustomMenu("exported/obachan/KanaMenu")
EndFunction

Function KanaMenu_Release(Form akClient)
	akClient.UnregisterForModEvent("UI_KanaMenuOpen")
	akClient.UnregisterForModEvent("UI_KanaMenuClose")
	akClient.UnregisterForModEvent("UI_KanaMenuCaret")
	akClient.UnregisterForModEvent("UI_KanaMenuStock")
	akClient.UnregisterForModEvent("UI_KanaMenuConsole")
EndFunction

Function KanaMenu_SetData(String asInitialText = "")
	Int iHandle = UICallback.Create("CustomMenu", "_root.KanaMenu_mc.initMenu")
	If iHandle
		UICallback.PushString(iHandle, asInitialText)
		UICallback.PushString(iHandle, stockwords[0])
		UICallback.PushString(iHandle, stockwords[1])
		UICallback.PushString(iHandle, stockwords[2])
		UICallback.PushString(iHandle, stockwords[3])
		UICallback.PushString(iHandle, stockwords[4])
		UICallback.PushString(iHandle, stockwords[5])
		UICallback.Send(iHandle)
	else
		debug.trace("@ [KanaMenu] initMenu失敗 - iHandleが作成できませんでした")
	endIf
EndFunction

Event OnKanaMenu(String asEventName, String asStringArg, Float afNumArg, Form akSender)
	If(asEventName == "UI_KanaMenuOpen")
		KanaMenu_SetData(sInitialText)
	elseIf(asEventName == "UI_KanaMenuClose")
		If(afNumArg as Bool)
			sInput = ""
		Else
			sInput = asStringArg
		EndIf
		bMenuOpen = False
	elseIf(asEventName == "UI_KanaMenuCaret")
		if (asStringArg == "save")
			caret = afNumArg as int
		elseif (asStringArg == "addInput")
			UI.InvokeInt("CustomMenu", "_root.KanaMenu_mc.addInputText2", caret)
		elseif (asStringArg == "delete")
			UI.InvokeInt("CustomMenu", "_root.KanaMenu_mc.deleteText2", caret)
		endif
	elseIf(asEventName == "UI_KanaMenuStock")
		stockwords = ArgString(asStringArg)
	elseIf(asEventName == "UI_KanaMenuConsole")
		consoleText = asStringArg
	EndIf
EndEvent

string[] function ArgString(string args, string delimiter = ",")
	string[] Output
	if args == ""
		return Output
	endIf
	int Next = StringUtil.Find(args, delimiter)
	if Next == -1
		Output = new String[1]
		Output[0] = args
		return Output
	endIf
	args += delimiter
	int Len = StringUtil.GetLength(args)
	int Count
	while Next != -1 && Next < Len
		Count += 1
		Next = StringUtil.Find(args, delimiter, (Next + 1))
	endWhile
	int i
	Output = Utility.CreateStringArray(Count)
	int DelimLen = StringUtil.GetLength(delimiter)
	int Prev
	Next = StringUtil.Find(args, delimiter)
	while Next != -1 && Next < Len
		Output[i] = Trim(StringUtil.SubString(args, Prev, (Next - Prev)))
		Prev = Next + DelimLen
		Next = StringUtil.Find(args, delimiter, Prev)
		i += 1
	endWhile
	return Output
endFunction

string function Trim(string var)
	if StringUtil.GetNthChar(var, 0) == " "
		return StringUtil.SubString(var, 1)
	endIf
	return var
endFunction